#!/usr/local/bin/ruby
#-*-Ruby-*-
# $Id: mhcdaily.cgi,v 1.3 2001-02-02 14:52:54+09 oharakun Exp oharakun $

require "web-mhc-conf"
require "web-mhc"
require "mhc-schedule"
require "cgi"

######################################################################
### Intializations
######################################################################

$query = CGI::new

Now = Time::now

if ($query['day'][0] =~ /^(\d\d\d\d)\/(\d\d)\/(\d\d)$/)
  year, mon, day = $1.to_i, $2.to_i, $3.to_i
elsif ($query['day'][0] =~ /^(\d\d)\/(\d\d)$/)
  year, mon, day = Now.year, $1.to_i, $2.to_i
elsif ($query['day'][0] =~ /^(\d\d)$/)
  year, mon, day = Now.year, Now.mon, $1.to_i
else
  year, mon, day = Now.year, Now.mon, Now.day
end

yyyy = sprintf("%04d", year)
mm = sprintf("%02d", mon)
dd = sprintf("%02d", day)

NextTarget = "schedule"

######################################################################
### SubRoutines
######################################################################

######################################################################
### Main
######################################################################

print "Content-Type: text/html\n"
print "\n"

sDB = MhcScheduleDB::new

print <<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-2022-JP">
<title>MHC Daily Index (#{yyyy}/#{mm}/#{dd})</title>
</head>

<body>

<p>#{yyyy}/#{mm}/#{dd}</p>

<table border=1>

<tr><th>Time</th><th>schedule</th></tr>
<tr><td colspan=2></td></tr>

EOT

the_day = MhcDate::new(year.to_i, mon.to_i, day.to_i)
sDB.search(the_day, the_day).each { |date, items|
  if (items.size == 0)
    print "<tr><td colspan=2>No Schedule on #{yyyy}/#{mm}/#{dd}</td></tr>\n"
  else
    items.each { |sch|
      time_as_string = (sch.time_as_string == '') ? "<br>" : sch.time_as_string

      if sch.path
	print "<tr><td>#{time_as_string}</td>\n"
	print "<td>"
	print "<a href=\"#{MHCCAT}?date=#{yyyy}#{mm}#{dd}&amp;path=#{substrPath(sch.path)}&amp;type=html\""
	print " target=\"#{NextTarget}\">"
	print "#{Kconv::tojis(CGI::escapeHTML(Kconv::toeuc(sch.subject)))}"
	print "</a>"
	print "</td></tr>\n"
      else
	print "<tr><td>#{time_as_string}</td>\n"
	print "<td>"
	print "#{Kconv::tojis(CGI::escapeHTML(Kconv::toeuc(sch.subject)))}"
	print "</td></tr>\n"
      end
    }
  end
}

print <<EOT

</table>

</body>
</html>
EOT

exit 0
